﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace erettsegi0_Kugli
{
    struct sadatok
    {
        public int kör;
        public string név;
        public int bábuk;
    }

    class erettsegi0_Kugli
    {
        static void Main()
        {
            #region 1. 3. feladatok: Az adatok beolvasása, adatszerkezet feltöltése
            Console.WriteLine("1. 3. Feladatok: Adatok olvasása, adatszerkezet feltöltése");

            List<sadatok> adatok = new List<sadatok>();
            int jdb = 5; //játékosok száma
            int ksz = 4; //körök száma

            for (int k = 1; k <= ksz; k++)
                using (StreamReader sr = new StreamReader("eredm"+k+".txt"))
                {
                    for (int i = 0; i < jdb; i++)
                    {
                        sadatok adat = new sadatok()
                        {
                            kör = k,
                            név = sr.ReadLine(),
                            bábuk = int.Parse(sr.ReadLine()),
                        };
                        adatok.Add(adat);
                    }
                }
            #endregion

            #region 2. feladat: Kik szereztek hibapontot az első körben?
            Console.WriteLine("2. feladat: Kik szereztek hibapontot az első körben?");
            for (int i = 1; i < jdb; i++)
                if (adatok[i].bábuk < adatok[i - 1].bábuk) Console.WriteLine(adatok[i].név);
            #endregion

            #region 4. feladat: Összesített eredmények
            Console.WriteLine("4. Feladat: Összesített eredmények:");
            
            var stat = from i in adatok
                       where i.bábuk!=10
                       group i by i.név into g
                       orderby g.Sum(i => i.bábuk) descending
                       select new { Név = g.Key, Össz = g.Sum(i=> i.bábuk) };
            
            foreach (var i in stat) Console.WriteLine(i.Név + ' ' + i.Össz);
            #endregion

            #region 5. feladat: Legjobb eredmény
            Console.WriteLine("5. Feladat: Legjobb eredmény:");
            Console.WriteLine(stat.First().Név + ' ' + stat.First().Össz);
            #endregion

            #region 6. feladat: Kiesett versenyzők
            Console.WriteLine("6. Feladat: Kiesett versenyzők:");
           
            var kiesett = from i in adatok
                          where i.bábuk == 10
                          group i by i.név into g
                          select new { Név = g.Key, Tagok = g };

            foreach (var i in kiesett) Console.WriteLine("{0} {1}. körben",i.Név, i.Tagok.First().kör - 1);
            #endregion

            #region 7. feladat: Taroló versenyzők
            Console.WriteLine("7. Feladat: Taroló versenyzők:");
          
            var tarol = from i in adatok
                        where i.bábuk == 9
                        group i by i.név into g
                        select new { Név = g.Key, Tagok=g};
            
            foreach (var i in tarol) 
            {
                Console.Write(i.Név);
                foreach (var j in i.Tagok) Console.Write("  {0}. körben", j.kör);
                Console.WriteLine();
            }
            #endregion

            Console.ReadKey();
        }
    }
}
